"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.Client = void 0;
var core_interface_1 = require("@ideal-postcodes/core-interface");
var agent_1 = require("./agent");
/**
 * Default user agent string
 */
var USER_AGENT = "IdealPostcodes ideal-postcodes/core-node";
var Client = /** @class */ (function (_super) {
    __extends(Client, _super);
    /**
     * Client constructor extends CoreInterface by also accepting an optional got
     * configuration object as the second argument.
     *
     * `got` is the underlying HTTP client that powers core-node. Be careful when
     * configuring `gotConfig` so as not to manually override critical request
     * attributes like method, query, header, etc. `got` confirmation options
     * available here: [github.com/sindresorhus/got#options](https://github.com/sindresorhus/got#options)
     */
    function Client(config, gotConfig) {
        if (gotConfig === void 0) { gotConfig = {}; }
        var _this = this;
        var agent = new agent_1.Agent(gotConfig);
        var header = { "User-Agent": USER_AGENT };
        _this = _super.call(this, __assign({ agent: agent }, __assign(__assign({}, config), { header: header }))) || this;
        return _this;
    }
    return Client;
}(core_interface_1.Client));
exports.Client = Client;
